require 'getopts'

a=getopts(nil, "japanese")

if $OPT_japanese
   japanese = true
else
   japanese = false
end

tempfile = "./doc/temp.rd"
indexfile = "./doc/index.rd"
jtarget = "./doc/Ref_man_j.rd"
etarget = "./doc/Ref_man_e.rd"
jparamlist = "./doc/Parameterlist_j.rd"
eparamlist = "./doc/Parameterlist_e.rd"

notsrcfile = ["./install.rb", "./parameter.rb", "./basic.rb", "./parameter_appli.rb", "./docgen.rb", "./paramlistgen.rb"]
srcdirfile = Dir["./*.rb"]
srcfile = Array.new

srcdirfile.each{|i|
  notsrcfile.each_index{|j|
    if(i==notsrcfile[j])
      break
    elsif(j==notsrcfile.length-1)
      srcfile.push(i)
    end
  }
}

rdfiles = [ "./common.rd", "./dev.rd",  "./page.rd",  "./frame.rd",  "./fig.rd",  "./axis.rd",  "./lin.rd",  "./log.rd",  "./dateaxis.rd",  "./plot.rd",  "./contour.rd",  "./tone.rd",  "./vector.rd",  "./map.rd",  "./text.rd",  "./arrow.rd",  "./mark.rd",  "./three-d.rd",  "./bar.rd",  "./box.rd",  "./gap.rd",  "./errbar.rd"]

jwrite = false
ewrite = false
write = false
srcfile.each{|file|
   rdfile = file.gsub(/\.rb/, ".rd")
   temp = open(rdfile, "w")
   s = open(file, "r")
   if(japanese)
      s.each do |line|
	 if(/#japanese/ =~ line)
	    jwrite = true
	 elsif(/\=begin/ =~ line && jwrite==true)
	    write = true
	 elsif(/\=end/ =~ line)
	    write = false
	    jwrite = false
	 elsif(write)
	    temp.print line
	 end 
      end
   else
      s.each do |line|
	 if(/#english/ =~ line)
	    ewrite = true
	 elsif(/\=begin/ =~ line && ewrite)
	    write = true
	 elsif(/\=end/ =~ line)
	    write = false
	    ewrite = false
	 elsif(write)
	    temp.print line
	 end 
      end
   end
  
  temp.close
  s.close
}

t = open(tempfile, "w")
rdfiles.each{|file|
  temp = open(file, "r")
  data = temp.read
  t.write data
  temp.close
  File.delete(file)
}
t.close

r = open(tempfile, "r")
index = open(indexfile, "w")
ex = false
out = ''
r.each do |line|
  if(/=AdvancedDCL::/ =~ line)
    if(/=AdvancedDCL::Axis:/ =~ line)
      out = line.gsub("==", "    * ((<").gsub(/$/, ">))")
      index.print out
    else
      out = line.gsub("==", "  * ((<").gsub(/$/, ">))")
      index.print out
    end
  elsif(/---/ =~ line)
    ex = true
    if(/Axis::/ =~ line)
      out = line.gsub(/\(.+\)/, "").gsub(/---/, "      * ((<").gsub(/$/, ">))").chomp
    else
      out = line.gsub(/\(.+\)/, "").gsub(/---/, "    * ((<").gsub(/$/, ">))").chomp
    end
  elsif(ex == true)
    out = out + line
    index.print out
    ex = false
  end
end

index.close
r.close

if(japanese)
   w = open(jtarget, "w")
else
   w = open(etarget, "w")
end
r = open(tempfile, "r")
index = open(indexfile, "r")
adv = open('./advanceddcl.rd', "r")
w.write "=begin\n"
data = adv.read
w.write data
adv.close
File.delete('./advanceddcl.rd')
data = index.read
w.write data
index.close
File.delete(indexfile)
data = r.read
w.write data
r.close
File.delete(tempfile)
w.write "=end\n"
w.close

if(japanese)
   r = open(jtarget, "r")
   w = open(jparamlist, "w")
else
   r = open(etarget, "r")
   w = open(eparamlist, "w")
end

w.print "=begin\n"
write = false
common = false
r.each do |line|
   if(/==NumRu::/ =~ line)
      w.print line
   elsif(/^:[a-z]/ =~ line)
      w.print line
      write = true
   elsif(write == true)
      w.print line
      write = false
   elsif(/<!--finish-->/ =~ line)
      common = false
   elsif(common == true)
      w.print line
   elsif(/<!--start-->/ =~ line)
      common = true
   end
end
w.print "=end\n"
r.close
w.close
